#!/bin/sh
#install.sh
# This script is a shell script to install the dr-server, the librairies
# and the wrapper easily.
#
# A lot of improvement is needed...
#
# $Header: /cvsroot/ipfc/ipfc/install.sh,v 1.1 2001/06/27 20:47:57 adulau Exp $
#
# alex@thinkingsecure.com

id | grep "uid=0(" >/dev/null
if [ $? != "0" ]; then
        echo "error : this script must be run as root !";
        echo "";
        exit 1;
fi

echo "IPFC framework use a general root directory to store all files."
echo "";
printf "By default the directory is [/opt/ipfc] :"
if [ "$config_dir" = "" ]; then
        read config_dir
fi

if [ "$config_dir" = "" ]; then
        config_dir=/opt/ipfc
fi
abspath=`echo $config_dir | grep "^/"`
if [ "$abspath" = "" ]; then
        echo "Config directory must be an absolute path"
        echo ""
        exit 2
fi
echo "$config_dir" >./current/.rootpath
if [ ! -d $config_dir ]; then
	echo "the $config_dir is not existing, we will create it."
        mkdir $config_dir;
        if [ $? != 0 ]; then
                echo "ERROR: Failed to create directory $config_dir"
                echo ""
                exit 2
        fi
fi

cd current/source/dr-server
echo ""
echo "Compiling dr-server and installing it in $config_dir"
sh ./compile 

cd ..

echo ""
echo "Copying lib to $config_dir/lib/"

if [ ! -d $config_dir/lib ]; then
        echo "the $config_dir/lib is not existing, we will create it."
        mkdir $config_dir/lib;
        if [ $? != 0 ]; then
                echo "ERROR: Failed to create directory $config_dir/lib"
                echo ""
                exit 2
        fi
fi

cp -rf ./lib/* $config_dir/lib/

echo ""
echo "Copying wrapper to $config_dir/wrapper/"

if [ ! -d $config_dir/wrapper ]; then
        echo "the $config_dir/wrapper is not existing, we will create it."
        mkdir $config_dir/wrapper;
        if [ $? != 0 ]; then
                echo "ERROR: Failed to create directory $config_dir/wrapper"
                echo ""
                exit 2
        fi
fi

cp -rf ./wrapper/* $config_dir/wrapper/

echo ""
echo "Copying docs to $config_dir/docs/"

if [ ! -d $config_dir/docs ]; then
        echo "the $config_dir/docs is not existing, we will create it."
        mkdir $config_dir/docs;
        if [ $? != 0 ]; then
                echo "ERROR: Failed to create directory $config_dir/docs"
                echo ""
                exit 2
        fi
fi


echo ""
echo "Copying ipfc root path information to $config_dir"

cp -rf ../.rootpath $config_dir/.rootpath

echo ""
echo "ipfc install is completed"



