#
# $Id: process_apache_errorlog.pl,v 1.3 2001/12/15 18:29:38 fpmip Exp $
#

# Author : Tycho Fruru <tycho@fruru.com>

# Copyright (C) 2001 Tycho Fruru <tycho@fruru.com>
# Copyright (C) 2001 Conostix S.A. Luxembourg - Tycho Fruru <tycho@conostix.com>

# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#

print "Registering process_apache_errorlog\n";

sub process_apache_error_log_1($$$$) {
	my $dbh = shift;
	my $entry = shift;
	my $table_name = shift;
	my $r_sql_hash = shift;
	
	# make local copies so that we don't pollute the global variables
	my %sql_hash = %{$r_sql_hash};
	
	my $rc = 1;
	
	my $apache_line = $entry->{'content'}->[0]->{'apache-line'};
	if (!defined($apache_line)) { 
		warn "There is no apache-line entry !";
		return 0;
	}

	my $apache_last_time;
		
	if (ref($apache_line) eq "ARRAY") {
		my $index = 0;
		my $rc = 1;
		
		my $start_time = time();
		my $elapsed_time;
		my $speed;
		
		while (defined($apache_line->[$index]) && $rc==1) {
			
			if ($index % 1000 == 0) { 
				$elapsed_time = time()-$start_time;
				if ($index != 0) { 
					$speed = int($index / $elapsed_time);
				} else {
					$speed = 0;
				}
 				show_msg(3,"$index entries processed in $elapsed_time seconds, $speed per second.\n");
			}
		
		 	my %apache_sql_hash = %sql_hash;
			
			my $decoded_apache_line = decode_entry($apache_line->[$index]);
			
			
			$apache_sql_hash{'message'} = $decoded_apache_line;
			
			if ($decoded_apache_line =~ /^\[([^\]]+)\] .*$/) {
				$apache_sql_hash{"time"}=$1;
				$apache_last_time=$1;
			} else {
				if (defined($apache_last_time)) {
					$apache_sql_hash{'time'}=$apache_last_time;
					#show_msg(4,"Apache error line $decoded_apache_line not acceptable in entry nr. $index\n");
				}
			}
			
			$rc = insert_data_into_table($dbh,$table_name,\%apache_sql_hash);
			$index++;
		}
	} else { 
		warn "There are no apache-lines in this file !"; 
		$rc = 0; 
	}
			
	show_msg(5,"End of apache_error_log_1\n");
	
	return $rc; # 1 is ok, 0 is not ok
}

return 1;
